/******************************
  MODULO DE ASPA ~
*******************************/

//#include <afx.h>
//#include <afxwin.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
//#include <windef.h>
//#include <io.h>


const double kPI = 3.1415926535897932384626433832795;
typedef unsigned char CHAR; 

typedef CHAR *LPSTR,*LPCH; 

typedef unsigned char BYTE; 
typedef unsigned short WORD;
 
typedef BYTE *LPBYTE; 


typedef int BOOL;
typedef BOOL *LPBOOL;

 
/*******************************************
   VARIABLES GLOBALES , LOCALES AL MODULO */

WORD wXSize=0;
WORD wYSize=0;
WORD wChanels=1;
WORD wPixelSize=1;


LPBYTE data;

char entrada1[40];

char entrada2[40];

char salida1[40];

char path[140];

char completoentrada1[180];

char completoentrada2[180];

char completosalida1[180];
	
int vtamano=0;

int vparar=1;

/******************************************/

unsigned long int capacidad;

/* FUNCIONES */


int ponerAspas()
{
	int result = 0;

	unsigned long int d=0;

	unsigned long int aspas;
	unsigned long int posx,posy;
	float eje;
	double cose, sene;
	int minx, maxx, miny, maxy;
	int i;
	WORD xSize, ySize, chanels, pixelSize;
		

	FILE *p,*pos,*sal;
		
    if((p=fopen(completoentrada1,"rb"))==NULL)
	{
		printf("\nError al abrir el archivo");
		return 1;
	};

    if((pos=fopen(completoentrada2,"rb"))==NULL)
	{
		printf("\nError al abrir el archivo");
		return 1;
	};
	
	fread(&wXSize,sizeof(wXSize),1,p);
	fread(&wYSize,sizeof(wYSize),1,p);
	fread(&wChanels,sizeof(wChanels),1,p);
	fread(&wPixelSize,sizeof(wPixelSize),1,p);
	
	capacidad=wXSize*wYSize*wChanels*wPixelSize;

	printf("capacidad=%dX%d=%d\n",wXSize, wYSize, capacidad);
	data=::new BYTE[capacidad];


	if(fread(data,sizeof(unsigned char),capacidad,p)!=capacidad)
	{
		printf("\nError de archivo");
		fclose(p);
		fclose(pos);
		return 1;
	}

	// creamos LA SALIDA

	if((sal=fopen(completosalida1,"wb"))==NULL)
	{
		printf("\nError al crear el archivo");
		fclose(p);
		fclose(pos);
		return 1;
	};


	fwrite(&wXSize,sizeof(wXSize),1,sal);
	fwrite(&wYSize,sizeof(wYSize),1,sal);
	fwrite(&wChanels,sizeof(wChanels),1,sal);
	fwrite(&wPixelSize,sizeof(wPixelSize),1,sal);
	

	fread(&xSize,sizeof(wXSize),1,pos);
	fread(&ySize,sizeof(wYSize),1,pos);
	fread(&chanels,sizeof(wChanels),1,pos);
	fread(&pixelSize,sizeof(wPixelSize),1,pos);

	// Si la imagen no tiene blobs
	if ((wXSize==0) || (wYSize==0))
	{
		printf("\nLa imagen est vacia");
		fclose(p);
		fclose(pos);
		return 1;
	}

	// Si la imagen no tiene tres columnas o 1 canal de floats
	if ((wXSize!=3) || (chanels!=1) || (pixelSize!=4))
	{
		printf("\nLa tiene un formato no valido");
		fclose(p);
		fclose(pos);
		return 1;
	}

	float posxf, posyf;

	// El numero de blobs es el tamao Y
	aspas = (unsigned long int) wYSize;

	for(d=0;d<aspas;d++)
	{
		fread(&posxf,sizeof(float),1,pos);
		fread(&posyf,sizeof(float),1,pos);
		fread(&eje,sizeof(float),1,pos);

		posx = (unsigned long int) posxf;
		posy = (unsigned long int) posyf;

		if(posx>=wXSize || posy>=wYSize)
		{
			printf("\nError: coordenadas fuera de rango. %d=>(%d,%d)", d, posx,posy);
			result = 1;
			continue;
		}

		printf("Centro (%d,%d)\tEje %f\n",posx, posy, eje);

		minx = posx - vtamano;
		minx = minx<0?0:minx;
		miny = posy - vtamano;
		miny = miny<0?0:miny;

		maxx = posx + vtamano;
		maxx = maxx>wXSize?wXSize:maxx;
		maxy = posy + vtamano;
		maxy = maxy>wYSize?wYSize:maxy;

		for(i=minx;i<maxx;i++)
			data[posy*wXSize+i] = 127;

		for(i=miny;i<maxy;i++)
			data[i*wXSize+posx] = 127;

		cose = cos(eje*kPI/180.0);
		sene = sin(eje*kPI/180.0);
		for(i=-vtamano;i<vtamano;i++)
		{
			minx = posx + (int)(i*cose);
			miny = posy - (int)(i*sene);

			// Si esta en los lmites escribo el aspa.
			if(minx>=0 && minx<wXSize &&
				miny>=0 && miny<wYSize )
				data[miny*wXSize+minx] = 127;
		}
	}

	if(fwrite(data,sizeof(unsigned char),capacidad,sal)!=capacidad)
	{
		printf("\nError de archivo");
		fclose(p);
		fclose(pos);
		fclose(sal);
		return 1;
	}

	fclose(p);
	fclose(pos);
	fclose(sal);

	return result;
}






void quitarasterisco()
{
	unsigned int i,j=0;
	char auxiliar[100];

	for(i=0,j=0;i<strlen(path);++i,++j)
	{
		if(path[i]=='*') auxiliar[j]=' ';
		else auxiliar[j]=path[i];
	}
	auxiliar[j]='\0';
	

	strcpy(completoentrada1,auxiliar);
	strcat(completoentrada1,entrada1);

	strcpy(completoentrada2,auxiliar);
	strcat(completoentrada2,entrada2);

	strcpy(completosalida1,auxiliar);
	strcat(completosalida1,salida1);


}

/*
		argv[0] => Nombre del ejecutable del modulo
		argv[1] => Funcin que debe hacer el modulo (debe ser 0)
		argv[2] => Numero de entradas que recibe el modulo (debe se 2)
		argv[3] => Numero de salidas que tiene el modulo (debe se 2)
		argv[4] => Path donde tratar con los archivos temporales.
		argv[5] => Tamao del aspa
		argv[6] => Parar ejecucin para ver resultados
		argv[7] => Nombre del archivo temporal de entrada
		argv[8] => Nombre del archivo temporal de entrada
		argv[9] => Nombre del archivo temporal de salida
   Esta funcin devuelve 0 si todo ha funcionado correctamente,
   y un valor mayor que 0 si ha habido algn error.
*/
int main(int argc, char* argv[])
{

	int i=0,my=0,mx=0;
	unsigned long int d=0;
	int result = 0;

	// Requiere 2 imagenes de entrada, 1 parmetro y una salida
	if (argc<9)
		return 20;

	int iNum = atoi(argv[2]);
	if (iNum != 2)
		return 20;
	
	iNum = atoi(argv[3]);
	if (iNum != 1)
		return 20;

	// lectura de parmetros
	strcpy(path,argv[4]);
	vtamano=atoi(argv[5]);
	vparar=atoi(argv[6]);
	if (vparar!=0)
		vparar=1;

	strcpy(entrada1,argv[7]);
	strcpy(entrada2,argv[8]);
	strcpy(salida1,argv[9]);

	quitarasterisco();

    result = ponerAspas();
	
	if (vparar==1)
	{
		printf("\nPulse ENTER para seguir\n");
		getchar();
	}

	delete data;

	return result;
}
